<template>
  <div class="select" :style="{ width: props.selectWidth }">
    <div class="input-wrapper">
      <input
        class="select-input"
        type="text"
        readonly
        :class="{ isopen: dropDownIsVisible }"
        v-model="selectedValue"
        ref="selectInput"
        @click="showDropDown"
        @keydown.down.prevent="keyDownHandler"
        @keydown.up.prevent="keyUpHandler"
        @keydown.enter.prevent="selectValue(selectedValue)"
      />
      <span
        class="select-arrow"
        :class="{ rotate: dropDownIsVisible }"
        @click="showDropDown"
      >
        <nuxt-icon class="icon-select" name="IconSelect" filled  />
      </span>
    </div>
    <BaseFieldErrors :errors="{ required: false, format: false }" />
    <BaseDropdownComponent
      v-if="dropDownIsVisible"
      ref="dropDown"
      v-model:dropDownIsVisible="dropDownIsVisible"
      v-model:selected-value="selectedValue"
      :dropdown-width="selectWidth"
      :dropdown-height="selectOptionsHeight"
      :arrow="{ right: '20px', show: false }"
      :dropdown-position="dropdownPosition"
      v-model:option-index="optionIndex"
    >
      <template v-slot:drop_content>
        <ul class="dropdown-content" :style="{ height: selectOptionsHeight }">
          <li
            ref="dropdownItem"
            class="dropdown-item"
            :class="{ selected: optionIndex === index }"
            v-for="(item, index) in selectOptions"
            :key="index"
            @click.prevent="selectValue(item)"
          >
            {{ item }}
          </li>
        </ul>
      </template>
    </BaseDropdownComponent>
  </div>
</template>

<script setup>
const props = defineProps({
  selectSelectedValue: String,
  selectWidth: String,
  selectOptions: Array,
  selectOptionsHeight: String,
  dropdownPosition: Object,
});
const emit = defineEmits(["update:selectSelectedValue"]);
const selectedValue = computed({
  get() {
    return props.selectSelectedValue ? props.selectSelectedValue : props.selectOptions[0]
  },
  set(value) {
    emit("update:selectSelectedValue", value);
  }
});
const dropDown = ref(null);
const dropDownIsVisible = ref(false);
const selectInput = ref(null);
const optionIndex = ref(0);
const dropdownItem = ref(null);
const showDropDown = () => {
  selectInput.value.focus();
  dropDownIsVisible.value = !dropDownIsVisible.value;
};
const keyDownHandler = () => {
  if (optionIndex.value < props.selectOptions.length - 1) optionIndex.value++;
  else optionIndex.value = 0;
  dropdownItem.value[optionIndex.value].scrollIntoView({
    block: "center",
    behavior: "smooth",
  });
  selectedValue.value = dropdownItem.value[optionIndex.value].innerText;
};
const keyUpHandler = () => {
  if (optionIndex.value > 0) optionIndex.value--;
  else optionIndex.value = props.selectOptions.length - 1;
  dropdownItem.value[optionIndex.value].scrollIntoView({
    block: "center",
    behavior: "smooth",
  });
  selectedValue.value = dropdownItem.value[optionIndex.value].innerText;
};
const selectValue = (item) => {
  selectedValue.value = item;
  emit("update:selectSelectedValue", item);
  dropDownIsVisible.value = false;
};

onMounted(() => {
  if (!props.selectSelectedValue)
    emit("update:selectSelectedValue", props.selectOptions[0]);
});
</script>

<style lang="sass">
@import '/assets/styles/_variables.sass'

.select
    box-sizing: border-box
    border-radius: 2px
    padding: 1rem auto
    cursor: pointer
    height: 2rem
    display: block
    position: relative
    &-input
        width: 100%
        padding: .5rem
        cursor: pointer
        margin: 0
        border: 1px solid $darkgrey
        border-radius: 3px
    &-arrow
        transition: .3s ease
        position: absolute
        top: 12%
        right: 3%
        .icon
          &-select
            svg
              width: $fz * 1.5
.dropdown
    &-content
        margin: 0
        width: 100%
        height: 5rem
        position: relative
        z-index: 9
        background: $white
        overflow-x: auto
        scroll-behavior: smooth
        scrollbar-color: $lightgrey transparent
        scrollbar-width: 8px
        &::-webkit-scrollbar
            background-color:  transparent
            width: 6px
        &::-webkit-scrollbar-thumb
            border-radius: 4px
            min-height: 40px
            background-color: $lightgrey
            border: 1px solid $darkgrey
    &-item
        list-style: none
        margin: .25rem 0
        text-align: center
        &:hover
            cursor: pointer
            background: $lightgrey
.selected
    background: $lightgrey
.rotate
    transition: .3s ease
    transform: rotateX(-180deg)
    top: 30%
    .select-arrow
        fill: #033fc0fc
.isopen
    border: 1px solid #033fc0fc
</style>
